using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MrHomer;
using DuffBeer.Communication;
using DONUT.FakePlugins;

namespace DONUT
{
    public partial class ErrorLogWindow : Form
    {
        internal delegate void DelayedMessage(string message);

        public ErrorLogWindow()
        {
            ITask err = new ErrorDumpTask();
            err.InitializeTask("Errors", new object[] { new ErrorManager.ErrorPrinter(LogError) });
            CommunicationManager.getInstance().AddTask(err);
            InitializeComponent();
        }

        public void LogError(Exception e)
        {
            LogMessage(e.ToString());
        }

        public void LogMessage(string message)
        {
            if (txtLog.IsDisposed) return;
            if (txtLog.InvokeRequired)
            {
                txtLog.BeginInvoke(new DelayedMessage(LogMessage), message);
            }
            else
            {
                txtLog.Text += message + "\n";
                txtLog.SelectionStart = txtLog.Text.Length;
                txtLog.SelectionLength = 0;
                txtLog.ScrollToCaret();
            }
        }
    }
}