using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using DuffBeer;

namespace DONUT
{
    public partial class LoadingDialog : Form
    {
        double theta;
        double r;
        double halfpi;
        MainForm form;
        string variable;
        public LoadingDialog(MainForm form, string VariableName)
        {
            variable = VariableName;
            this.form = form;
            InitializeComponent();
            r = 120;
            halfpi = Math.PI / 2;
            panel1.Visible = false;
            this.Location = new Point(form.Left + (this.Width - form.Width) / 2, form.Top + (this.Height - form.Height) / 2);
            pictureBox1.Image = new Bitmap(Resources.Donut, new Size(pictureBox1.Width, pictureBox1.Height));
            pictureBox2.Image = pictureBox1.Image;
            pictureBox3.Image = pictureBox1.Image;
            pictureBox4.Image = pictureBox1.Image;
            pictureBox1.BackColor = Color.Transparent;
            pictureBox2.BackColor = Color.Transparent;
            pictureBox3.BackColor = Color.Transparent;
            pictureBox4.BackColor = Color.Transparent;
            pictureBox1.Visible = false;
            pictureBox2.Visible = false;
            pictureBox3.Visible = false;
            pictureBox4.Visible = false;
            pictureBox1.Location = new Point((int)(Math.Cos(Math.PI * theta) * r) + this.Width / 2 - pictureBox1.Width / 2 - 10, (int)(Math.Sin((Math.PI * theta)) * r) + this.Height / 2 - pictureBox1.Width / 2 - 13);
            pictureBox2.Location = new Point((int)(Math.Cos(Math.PI * theta + halfpi) * r) + this.Width / 2 - pictureBox1.Width / 2 - 10, (int)(Math.Sin((Math.PI * theta + halfpi)) * r) + this.Height / 2 - pictureBox1.Width / 2 - 13);
            pictureBox3.Location = new Point((int)(Math.Cos(Math.PI * theta + halfpi + halfpi) * r) + this.Width / 2 - pictureBox1.Width / 2 - 10, (int)(Math.Sin((Math.PI * theta + halfpi + halfpi)) * r) + this.Height / 2 - pictureBox1.Width / 2 - 13);
            pictureBox4.Location = new Point((int)(Math.Cos(Math.PI * theta + halfpi + halfpi + halfpi) * r) + this.Width / 2 - pictureBox1.Width / 2 - 10, (int)(Math.Sin((Math.PI * theta + halfpi + halfpi + halfpi)) * r) + this.Height / 2 - pictureBox1.Width / 2 - 13);

        }

        private void LoadingDialog_Load(object sender, EventArgs e)
        {
            panel1.Visible = true;
            pictureBox1.Visible = true;
            pictureBox2.Visible = true;
            pictureBox3.Visible = true;
            pictureBox4.Visible = true;
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);

            if (Brewery.getInstance().IsVariableSet(variable))
            {
                form.CompleteLoadingDialog();
                this.Close();
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            theta += 0.025;
            pictureBox1.Location = new Point((int)(Math.Cos(Math.PI * theta) * r) + this.Width / 2 - pictureBox1.Width / 2 - 10, (int)(Math.Sin((Math.PI * theta)) * r) + this.Height / 2 - pictureBox1.Width / 2 - 13);
            pictureBox2.Location = new Point((int)(Math.Cos(Math.PI * theta + halfpi) * r) + this.Width / 2 - pictureBox1.Width / 2 - 10, (int)(Math.Sin((Math.PI * theta + halfpi)) * r) + this.Height / 2 - pictureBox1.Width / 2 - 13);
            pictureBox3.Location = new Point((int)(Math.Cos(Math.PI * theta + halfpi + halfpi) * r) + this.Width / 2 - pictureBox1.Width / 2 - 10, (int)(Math.Sin((Math.PI * theta + halfpi + halfpi)) * r) + this.Height / 2 - pictureBox1.Width / 2 - 13);
            pictureBox4.Location = new Point((int)(Math.Cos(Math.PI * theta + halfpi + halfpi + halfpi) * r) + this.Width / 2 - pictureBox1.Width / 2 - 10, (int)(Math.Sin((Math.PI * theta + halfpi + halfpi + halfpi)) * r) + this.Height / 2 - pictureBox1.Width / 2 - 13);

            this.Refresh();
        }
    }
}