using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace DONUT
{
    static class LolGraph
    {

        static public Image DrawGraph(List<double> crap, int width, int height, DateTime time)
        {
            Bitmap graph = new Bitmap(width, height);
            Graphics g = Graphics.FromImage(graph);
            g.Clear(Color.White);

            double min = double.MaxValue;
            double max = 0;

            for (int i = 0; i < crap.Count; i++)
            {
                if (crap[i] < min)
                    min = crap[i];
                if (crap[i] > max)
                    max = crap[i];
            }
            Math.Round(min, 2);
            Math.Round(max, 2);

            int frame;
            if(width < height)
                frame = height / 8;
            else
                frame = width / 8;

            double wcoef = ((double)(width - 2 * frame)) / ((double)crap.Count-1);
            double hcoef = ((double)(height - 2 * frame)) / (max-min);

            g.DrawRectangle(Pens.Black, frame - 1, frame - 1, width - (2 * frame), height - (2 * frame) + 2);

            int startx, starty, endx, endy;
            for (int i = 1; i < crap.Count; i++)
            {
                startx = (int)((i - 1) * wcoef + (frame - 1));
                endx = (int)((i) * wcoef + (frame - 1));
                starty = (int)((height - frame) - ((crap[i - 1] - min) * hcoef));
                endy = (int)((height - frame) - ((crap[i] - min) * hcoef));
                g.DrawLine(Pens.CornflowerBlue, startx, starty, endx, endy);
            }

            g.DrawString("Minimum: " + min, new Font(FontFamily.Families[0], 10), new SolidBrush(Color.Black), new PointF(frame / 2, height - frame / 2));
            g.DrawString("Maximum: " + max, new Font(FontFamily.Families[0], 10), new SolidBrush(Color.Black), new PointF(frame / 2, frame / 2));
            g.DrawString(time.ToString(), new Font(FontFamily.Families[0], 10), new SolidBrush(Color.Black), new PointF(width - time.ToString().Length *10 - frame/2, frame / 2)); 

            return graph;
        }
    }
}
