using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Networking;

namespace DuffBeer.Communication
{
    public class DisconnectionTask : ITask
    {
        #region ITask Members

        private string myName;
        private object[] myData;

        public void PerformTask()
        {
            ConnectionManager.getInstance().KillInactiveConnection(myName);
            ConnectionManager.getInstance().KillActiveConnection(myName);
            if (CommunicationManager.getInstance().LowerConnections.Contains(myName))
            {
                CommunicationManager.getInstance().LowerConnections.Remove(myName);
            }
            if (CommunicationManager.getInstance().TempLowerConnections.Contains(myName))
            {
                CommunicationManager.getInstance().TempLowerConnections.Remove(myName);
            }
            if (CommunicationManager.getInstance().HigherConnections.Contains(myName))
            {
                CommunicationManager.getInstance().HigherConnections.Remove(myName);
            }
            if (CommunicationManager.getInstance().TempHigherConnections.Contains(myName))
            {
                CommunicationManager.getInstance().TempHigherConnections.Remove(myName);
            }
        }

        public void InitializeTask(string name, object[] data)
        {
            myName = name;
            myData = data.Clone() as object[];
        }

        #endregion
    }
}
