using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Communication;
using DuffBeer.Database;
using MrHomer.Networking;

namespace DuffBeer.Communication
{
    public class InitializationTask : ITask
    {
        #region ITask Members
        ConnectionManager cm;
        CommunicationManager cnm;
        int port;

        public void PerformTask()
        {
            cm.ListenForConnection(port, true);

            cnm.AddTask(new ActivationTask(port));
            RecvDataTask task = new RecvDataTask();
            task.InitializeTask(null, null);
            cnm.AddTask(task);
        }

        public void InitializeTask(string name, object[] data)
        {
            port = (int)data[0];
            cm = ConnectionManager.getInstance();
            cnm = CommunicationManager.getInstance();
        }

        #endregion
    }
}
