using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Messages;
using MrHomer;
using MrHomer.Networking;
using MrHomer.Security;
using System.Threading;

namespace DuffBeer.Communication
{
    public class RecvDataTask : ITask
    {
        #region ITask Members

        MessageManager ms;
        SecurityManager sm;
        ConnectionManager cs;
        CommunicationManager cms;

        public void PerformTask()
        {
            foreach (string s in cs.GetAllActiveConnections())
            {
                cs.CheckForDisconnect(s);
                foreach (byte[] l in cs.GetData(s, true))
                {
                    try
                    {
                        Packet p = new Packet(sm.Decrypt(l, sm.GetKey(s, new object[] { }), new object[] { }));
                        ms.Handle(p, s);
                    }
                    catch (Exception e)
                    {
                        ErrorManager.getInstance().Catch(e);
                    }
                }
            }
            RecvDataTask task = new RecvDataTask();
            task.InitializeTask(null, null);
            cms.AddTask(task);
        }

        public void InitializeTask(string name, object[] data)
        {
            ms = MessageManager.getInstance();
            cs = ConnectionManager.getInstance();
            cms = CommunicationManager.getInstance();
            sm = SecurityManager.getInstance();
        }

        #endregion
    }
}
