using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Networking;
using MrHomer.Security;

namespace DuffBeer.Communication
{
    public class SendDataTask : ITask
    {
        Packet myData;
        string myName;
        byte[] myKey;
        object[] myInfo;

        #region ITask Members

        public void PerformTask()
        {
            byte[] data = SecurityManager.getInstance().Encrypt(myData.Serialize(), myKey, myInfo);
            ConnectionManager.getInstance().SendData(myName, data);
        }

        public void InitializeTask(string name, object[] data)
        {
            myName = name;
            myData = data[0] as Packet;
            myKey = data[1] as byte[];
            myInfo = data[2] as object[];
        }

        #endregion
    }
}
