using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;
using MrHomer.Plugins;

namespace DuffBeer.Database
{
    [MrHomerPlugin("Type", "MSSQL_NTAuth")]
    public class SQL_Database_NTAuth : SQL_Database
    {
        /// <summary>
        /// Creates a new NT-Authenticated MS SQL database
        /// </summary>
        public SQL_Database_NTAuth() : base() { }

        /// <summary>
        /// Connects to the database
        /// </summary>
        /// <param name="dataSource">The DSN (usually hostname and port)</param>
        /// <param name="username">The username (ignored)</param>
        /// <param name="password">The password (ignored)</param>
        /// <param name="database">The database to use</param>
        public override bool Connect(string dataSource, string username, string password, string database)
        {
            SqlConnectionStringBuilder n = new SqlConnectionStringBuilder();

            n.DataSource = dataSource;
            n.IntegratedSecurity = true;
            n.InitialCatalog = database;

            try
            {
                conn = new SqlConnection(n.ConnectionString);
                conn.Open();
            }
            catch
            {
                conn = null;
                return false;
            }

            return true;
        }
    }
}
