using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Database;

namespace DuffBeer.Database.StructureTypes
{
    public class ConnectionInitiationTableEntry : TableEntry
    {
        static public string HostUPRNColumn
        {
            get { return "HostUPRN"; }
        }

        static public string HostAddressColumn
        {
            get { return "HostAddress"; }
        }

        public string HostUPRN
        {
            get { return myTableRef.Row[HostUPRNColumn]; }
            set { myTableRef.Row[HostUPRNColumn] = value; }
        }
        public string HostAddress
        {
            get { return myTableRef.Row[HostAddressColumn]; }
            set { myTableRef.Row[HostAddressColumn] = value; }
        }

        public ConnectionInitiationTableEntry()
            : base(DuffBeerDatabaseConfig.ConnectionInitiationTable)
        {
            
        }

        public ConnectionInitiationTableEntry(int RowID)
            : this()
        {
            myTableRef.Find("ID", RowID.ToString());
        }

        public ConnectionInitiationTableEntry(string HostUPRN, string HostAddress)
            : this()
        {
            myTableRef.AddRow();
            this.HostUPRN = HostUPRN;
            this.HostAddress = HostAddress;
        }

        public static ConnectionInitiationTableEntry Find(string Column, string Value)
        {
            DataTable t = new DataTable(DatabaseManager.getInstance().FindDatabase(DuffBeerDatabaseConfig.DatabaseName), DatabaseManager.getInstance().GetQueryBuilder(DuffBeerDatabaseConfig.DatabaseName), DuffBeerDatabaseConfig.ConnectionInitiationTable, TableEntry.IDColumn);
            if (t.Find(Column, Value))
                return new ConnectionInitiationTableEntry(int.Parse(t.Row[TableEntry.IDColumn]));
            else
                return null;
        }
    }
}
