using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Database;

namespace DuffBeer.Database.StructureTypes
{
    public class FiltersTableEntry : TableEntry
    {
        static public string SensorColumn
        {
            get { return "Sensor"; }
        }
        static public string CodeTypeColumn
        {
            get { return "CodeType"; }
        }
        static public string StateColumn
        {
            get { return "State"; }
        }

        public int Sensor
        {
            get { return int.Parse(myTableRef.Row[SensorColumn]); }
            set { myTableRef.Row[SensorColumn] = value.ToString(); }
        }

        public string CodeType
        {
            get { return myTableRef.Row[CodeTypeColumn]; }
            set { myTableRef.Row[CodeTypeColumn] = value; }
        }

        public byte[] State
        {
            get { return Encoding.UTF8.GetBytes(myTableRef.Row[StateColumn]); }
            set { myTableRef.Row[StateColumn] = Encoding.UTF8.GetString(value); }
        }


        public FiltersTableEntry()
            : base(DuffBeerDatabaseConfig.FiltersTable)
        {
        }

        public FiltersTableEntry(int RowID)
            : this()
        {
            myTableRef = new DataTable(DatabaseManager.getInstance().FindDatabase(DuffBeerDatabaseConfig.DatabaseName), DatabaseManager.getInstance().GetQueryBuilder(DuffBeerDatabaseConfig.DatabaseName), DuffBeerDatabaseConfig.FiltersTable, "ID");
            myTableRef.Find("ID", RowID.ToString());
        }

        public FiltersTableEntry(int Sensor, string CodeType, byte[] State)
            : this()
        {
            myTableRef.AddRow();
            this.Sensor = Sensor;
            this.CodeType = CodeType;
            this.State = State;
        }

        public static FiltersTableEntry Find(string Column, string Value)
        {
            DataTable t = new DataTable(DatabaseManager.getInstance().FindDatabase(DuffBeerDatabaseConfig.DatabaseName), DatabaseManager.getInstance().GetQueryBuilder(DuffBeerDatabaseConfig.DatabaseName), DuffBeerDatabaseConfig.FiltersTable, "ID");
            if (t.Find(Column, Value))
                return new FiltersTableEntry(int.Parse(t.Row["ID"]));
            else
                return null;
        }
    }
}
