using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Database;

namespace DuffBeer.Database.StructureTypes
{
    public class RegisteredUsersTableEntry : TableEntry
    {
        static public string UsernameColumn
        {
            get { return "Username"; }
        }

        static public string PasswordColumn
        {
            get { return "Password"; }
        }

        static public string FlagsColumn
        {
            get { return "Cascading"; }
        }

        public string UserName
        {
            get { return myTableRef.Row[UsernameColumn]; }
            set { myTableRef.Row[UsernameColumn] = value; }
        }

        public string Password
        {
            get { return myTableRef.Row[PasswordColumn]; }
            set { myTableRef.Row[PasswordColumn] = value; }
        }

        public int Flags
        {
            get { return bool.Parse((myTableRef.Row[FlagsColumn])) ? 1 : 0; }
            set { myTableRef.Row[FlagsColumn] = value.ToString(); }
        }

        public RegisteredUsersTableEntry()
            : base(DuffBeerDatabaseConfig.RegisteredUsersTable)
        {
            
        }

        public RegisteredUsersTableEntry(int RowID)
            : this()
        {
            myTableRef.Find("ID", RowID.ToString());
        }

        public RegisteredUsersTableEntry(string UserName, string Password, int Flags)
            : this()
        {
            myTableRef.AddRow();
            this.UserName = UserName;
            this.Password = Password;
            this.Flags = Flags;
        }

        public static RegisteredUsersTableEntry Find(string Column, string Value)
        {
            DataTable t = new DataTable(DatabaseManager.getInstance().FindDatabase(DuffBeerDatabaseConfig.DatabaseName), DatabaseManager.getInstance().GetQueryBuilder(DuffBeerDatabaseConfig.DatabaseName), DuffBeerDatabaseConfig.RegisteredUsersTable, "ID");
            if (t.Find(Column, Value))
                return new RegisteredUsersTableEntry(int.Parse(t.Row["ID"]));
            else
                return null;
        }
    }
}
