using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Database;

namespace DuffBeer.Database.StructureTypes
{
    public class SearchCacheTableEntry : TableEntry
    {
        static public string SearchStringColumn
        {
            get { return "SearchString"; }
        }
        static public string PrimaryResultColumn
        {
            get { return "PrimaryResult"; }
        }

        static public string SecondaryResultColumn
        {
            get { return "SecondaryResult"; }
        }

        public string SearchString
        {
            get { return myTableRef.Row[SearchStringColumn]; }
            set { myTableRef.Row[SearchStringColumn] = value; }
        }
        public string PrimaryResult
        {
            get { return myTableRef.Row[PrimaryResultColumn]; }
            set { myTableRef.Row[PrimaryResultColumn] = value; }
        }

        public string SecondaryResult
        {
            get { return myTableRef.Row[SecondaryResultColumn]; }
            set { myTableRef.Row[SecondaryResultColumn] = value; }
        }

        public SearchCacheTableEntry()
            : base(DuffBeerDatabaseConfig.LocationSearchCache)
        {
        }

        public SearchCacheTableEntry(int RowID)
            : this()
        {
            myTableRef.Find("ID", RowID.ToString());
        }

        public SearchCacheTableEntry(string SearchString, string PrimaryResult, string SecondaryResult)
            : this()
        {
            myTableRef.AddRow();
            this.SearchString = SearchString;
            this.PrimaryResult = PrimaryResult;
            this.SecondaryResult = SecondaryResult;
        }

        public static SearchCacheTableEntry Find(string Column, string Value)
        {
            DataTable t = new DataTable(DatabaseManager.getInstance().FindDatabase(DuffBeerDatabaseConfig.DatabaseName), DatabaseManager.getInstance().GetQueryBuilder(DuffBeerDatabaseConfig.DatabaseName), DuffBeerDatabaseConfig.LocationSearchCache, "ID");
            if (t.Find(Column, Value))
                return new SearchCacheTableEntry(int.Parse(t.Row["ID"]));
            else
                return null;
        }
    }
}
