using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Database;

namespace DuffBeer.Database.StructureTypes
{
    public class SensorsTableEntry : TableEntry
    {
        static public string NameColumn
        {
            get { return "Name"; }
        }

        static public string TypeColumn
        {
            get { return "Type"; }
        }

        static public string RefreshRateColumn
        {
            get { return "RefreshRate"; }
        }

        static public string UnitsColumn
        {
            get { return "Units"; }
        }

        static public string CodeTypeColumn
        {
            get { return "CodeType"; }
        }

        static public string StateColumn
        {
            get { return "State"; }
        }

        public string Name
        {
            get { return myTableRef.Row[NameColumn]; }
            set { myTableRef.Row[NameColumn] = value; }
        }

        public string Type
        {
            get { return myTableRef.Row[TypeColumn]; }
            set { myTableRef.Row[TypeColumn] = value; }
        }

        public int RefreshRate
        {
            get { return int.Parse(myTableRef.Row[RefreshRateColumn]); }
            set { myTableRef.Row[RefreshRateColumn] = value.ToString(); }
        }

        public string Units
        {
            get { return myTableRef.Row[UnitsColumn]; }
            set { myTableRef.Row[UnitsColumn] = value; }
        }

        public string CodeType
        {
            get { return myTableRef.Row[CodeTypeColumn];}
            set { myTableRef.Row[CodeTypeColumn] = value; }
        }

        public byte[] State
        {
            get { return Encoding.UTF8.GetBytes(myTableRef.Row[StateColumn]); }
            set { myTableRef.Row[StateColumn] = Encoding.UTF8.GetString(value); }
        }

        public SensorsTableEntry()
            : base(DuffBeerDatabaseConfig.SensorsTable)
        {
        }

        public SensorsTableEntry(int RowID)
            : this()
        {
            myTableRef.Find("ID", RowID.ToString());
        }

        public SensorsTableEntry(string Name, string Type, int RefreshRate, string Units, string CodeType, byte[] State)
            : this()
        {
            myTableRef.AddRow();
            this.Name = Name;
            this.Type = Type;
            this.RefreshRate = RefreshRate;
            this.Units = Units;
            this.CodeType = CodeType;
            this.State = State;
        }

        public static SensorsTableEntry Find(string Column, string Value)
        {
            DataTable t = new DataTable(DatabaseManager.getInstance().FindDatabase(DuffBeerDatabaseConfig.DatabaseName), DatabaseManager.getInstance().GetQueryBuilder(DuffBeerDatabaseConfig.DatabaseName), DuffBeerDatabaseConfig.SensorsTable, "ID");
            if (t.Find(Column, Value))
                return new SensorsTableEntry(int.Parse(t.Row["ID"]));
            else
                return null;
        }
    }
}
