using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Database;

namespace DuffBeer.Database.StructureTypes
{
    public class SnapshotsTableEntry : TableEntry
    {
        static public string SensorColumn
        {
            get { return "Sensor"; }
        }

        static public string AverageColumn
        {
            get { return "Average"; }
        }

        static public string MinimumColumn
        {
            get { return "Minimum"; }
        }
        static public string MaximumColumn
        {
            get { return "Maximum"; }
        }
        static public string TotalColumn
        {
            get { return "Total"; }
        }
        static public string TimestampColumn
        {
            get { return "Timestamp"; }
        }
        static public string DurationColumn
        {
            get { return "Duration"; }
        }

        public int Sensor
        {
            get { return int.Parse(myTableRef.Row[SensorColumn]); }
            set { myTableRef.Row[SensorColumn] = value.ToString(); }
        }

        public double Average
        {
            get { return double.Parse(myTableRef.Row[AverageColumn]); }
            set { myTableRef.Row[AverageColumn] = value.ToString(); }
        }

        public double Minimum
        {
            get { return double.Parse(myTableRef.Row[MinimumColumn]); }
            set { myTableRef.Row[MinimumColumn] = value.ToString(); }
        }

        public double Maximum
        {
            get { return double.Parse(myTableRef.Row[MaximumColumn]); }
            set { myTableRef.Row[MaximumColumn] = value.ToString(); }
        }

        public double Total
        {
            get { return double.Parse(myTableRef.Row[TotalColumn]); }
            set { myTableRef.Row[TotalColumn] = value.ToString(); }
        }

        public string Timestamp
        {
            get { return /*DateTime.Parse(*/myTableRef.Row[TimestampColumn]/*)*/; }
            set { myTableRef.Row[TimestampColumn] = value.ToString(); }
        }

        public double Duration
        {
            get { return double.Parse(myTableRef.Row[DurationColumn]); }
            set { myTableRef.Row[DurationColumn] = value.ToString(); }
        }

        public SnapshotsTableEntry()
            : base(DuffBeerDatabaseConfig.SnapshotsTable)
        {
        }

        public SnapshotsTableEntry(int RowID)
            : this()
        {
            myTableRef.Find("ID", RowID.ToString());
        }

        public SnapshotsTableEntry(int Sensor, double Average, double Minimum, double Maximum, double Total, string Timestamp, double Duration)
            : this()
        {
            myTableRef.AddRow();
            this.Sensor = Sensor;
            this.Average = Average;
            this.Minimum = Minimum;
            this.Maximum = Maximum;
            this.Total = Total;
            this.Timestamp = Timestamp;
            this.Duration = Duration;
        }

        public static SnapshotsTableEntry Find(string Column, string Value)
        {
            DataTable t = new DataTable(DatabaseManager.getInstance().FindDatabase(DuffBeerDatabaseConfig.DatabaseName), DatabaseManager.getInstance().GetQueryBuilder(DuffBeerDatabaseConfig.DatabaseName), DuffBeerDatabaseConfig.SnapshotsTable, "ID");
            t.Sort(TimestampColumn, DataTable.SortOrder.Descending);
            if (t.Find(Column, Value))
                return new SnapshotsTableEntry(int.Parse(t.Row["ID"]));
            else
                return null;
        }
    }
}
