using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Database;

namespace DuffBeer.Database.StructureTypes
{
    public class SystemsTableEntry : TableEntry
    {
        static public string HostIDColumn
        {
            get { return "HostID"; }
        }

        public string HostID
        {
            get { return myTableRef.Row[HostIDColumn]; }
            set { myTableRef.Row[HostIDColumn] = value; }
        }

        public SystemsTableEntry(string whichTable)
            : base(whichTable)
        {
        }

        public SystemsTableEntry(string whichTable, int RowID)
            : this(whichTable)
        {
            myTableRef.Find("ID", RowID.ToString());
        }

        public SystemsTableEntry(string whichTable, string HostID)
            : this(whichTable)
        {
            myTableRef.AddRow();
            this.HostID = HostID;
        }

        public static SystemsTableEntry Find(string whichTable, string Column, string Value)
        {
            DataTable t = new DataTable(DatabaseManager.getInstance().FindDatabase(DuffBeerDatabaseConfig.DatabaseName), DatabaseManager.getInstance().GetQueryBuilder(DuffBeerDatabaseConfig.DatabaseName), whichTable, "ID");
            if (t.Find(Column, Value))
                return new SystemsTableEntry(whichTable, int.Parse(t.Row["ID"]));
            else
                return null;
        }
    }
}
