using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Database;

namespace DuffBeer.Database.StructureTypes
{
    public abstract class TableEntry
    {
        protected DataTable myTableRef;

        public int RowCount
        {
            get { return myTableRef.Count; }
        }

        public static string IDColumn { get { return "ID"; } }

        public int ID { get { return int.Parse(myTableRef.Row["ID"]); } }

        /// <summary>
        /// Creates a new TableEntry
        /// </summary>
        /// <param name="TableName">The table name in the database</param>
        public TableEntry(string TableName)
        {
            myTableRef = new DataTable(DatabaseManager.getInstance().FindDatabase(DuffBeerDatabaseConfig.DatabaseName), DatabaseManager.getInstance().GetQueryBuilder(DuffBeerDatabaseConfig.DatabaseName), TableName, IDColumn);
            myTableRef.MoveFirst();
        }

        /// <summary>
        /// Saves changes to this entry
        /// </summary>
        public void Save()
        {
            myTableRef.SaveRow();
        }

        /// <summary>
        /// Deletes this entry from the table
        /// </summary>
        public void Delete()
        {
            myTableRef.DeleteRow();
        }

        /// <summary>
        /// Moves to the next entry
        /// </summary>
        public bool Next()
        {
            return myTableRef.MoveNext();
        }
    }
}
