using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Database.StructureTypes;

namespace DuffBeer.Main
{
    public class SearchCache
    {
        static private SearchCache instance;

        static public SearchCache getInstance()
        {
            if (instance == null)
                instance = new SearchCache();
            return instance;
        }

        private List<SearchResult> results;

        private SearchCache()
        {
            WipeCache();
        }

        public void PullFromDB()
        {
            SearchCacheTableEntry table = new SearchCacheTableEntry();
            do
            {
                SearchResult s = new SearchResult();
                s.SearchValue = table.SearchString;
                s.MainResult = table.PrimaryResult;
                s.SecondaryResult = table.SecondaryResult;
                if(!results.Contains(s))
                    results.Add(s);
            } while (table.Next());
        }

        public void WriteToDB()
        {
            PullFromDB();
            WipeDB();
            foreach (SearchResult s in results)
            {
                SearchCacheTableEntry table = new SearchCacheTableEntry(s.SearchValue, s.MainResult, s.SecondaryResult);
                table.Save();
            }
        }

        public void WipeDB()
        {
            SearchCacheTableEntry table = new SearchCacheTableEntry();
            do
            {
                table.Delete();
            } while (table.Next());
        }

        public void WipeCache()
        {
            results = new List<SearchResult>();
        }

        public void AddResult(string SearchString, string Result1, string Result2)
        {
            SearchResult s = new SearchResult();
            s.MainResult = Result1;
            s.SecondaryResult = Result2;
            s.SearchValue = SearchString;
            if(!results.Contains(s))
                results.Add(s);

        }


        public List<SearchResult> GetResults(string SearchValue)
        {
            List<SearchResult> returnme = new List<SearchResult>();
            foreach (SearchResult s in results)
            {
                if (s.SearchValue == SearchValue)
                {
                    SearchResult a = new SearchResult();
                    a.SearchValue = s.SearchValue;
                    a.MainResult = s.MainResult;
                    a.SecondaryResult = s.SecondaryResult;
                    returnme.Add(a);
                }
            }
            return returnme;
        }

    }
}
