using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Messages;
using MrHomer.Plugins;
using MrHomer.Networking;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "Requesting Configuration Setting")]
    public class ConfigurationValueRequestMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members

        //  Packet
        // Sender       =   Irrelevent
        // Recipient    =   Put Back In
        // Body         =   Config Key, Config Value

        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            StringData s = p.Body as StringData;
            s.Data = Brewery.getInstance().Config(s.Data);
            string subject = "";
            foreach (MrHomerPluginAttribute n in PluginManager.getInstance().getAttributes(typeof(ConfigurationValueResponseMessageHandler)))
            {
                if (n.Name == "Subject")
                    subject = n.Value;
            }
            Packet l = new Packet(Brewery.getInstance().UPRN, p.Recipient, subject, s);
            Communication.SendDataTask task = new DuffBeer.Communication.SendDataTask();
            task.InitializeTask(Connection, new object[] { l, MrHomer.Security.SecurityManager.getInstance().GetKey(Connection, new object[] { }), new object[] { } });
            Communication.CommunicationManager.getInstance().AddTask(task);
        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Chris Scalabrini"; }
        }

        public string Version
        {
            get { return "1.0"; }
        }

        public string Label
        {
            get { return "Sends back the configuration value."; }
        }

        #endregion
    }
}
