using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Messages;
using MrHomer.Plugins;
using MrHomer.Networking;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "Configuration Setting Data")]
    public class ConfigurationValueResponseMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members


        //  Packet
        // Sender       =   Irrelevent
        // Recipient    =   Brewery Value
        // Body         =   Data

        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            StringData s = p.Body as StringData;
            Brewery.getInstance().SetVariable(p.Recipient, s.Data);
        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Chris Scalabrini"; }
        }

        public string Version
        {
            get { return "1.0"; }
        }

        public string Label
        {
            get { return "Processes a configuration setting response packet."; }
        }

        #endregion
    }
}
