using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Messages;
using MrHomer.Plugins;
using MrHomer.Networking;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "Forward")]
    public class ForwardedMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members

        //  Packet
        // Sender       =   Irrelevent
        // Recipient    =   The connection to send the new packet to.
        // Body         =   The packet to send.

        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            Packet l = (p.Body as Serialization.PacketData).data;

            DuffBeer.Communication.SendDataTask task = new DuffBeer.Communication.SendDataTask();
            task.InitializeTask(p.Recipient, new object[] {l, MrHomer.Security.SecurityManager.getInstance().GetKey(p.Recipient, new object[]{})});
            Communication.CommunicationManager.getInstance().AddTask(task);
        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Chris Scalabrini"; }
        }

        public string Version
        {
            get { return "1.0"; }
        }

        public string Label
        {
            get { return "Sends back sensor data."; }
        }

        #endregion
    }
}
