using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Messages;
using DuffBeer.Messages.ProgressTaskStructures;
using DuffBeer.Communication;
using DuffBeer.Main;
using MrHomer.Plugins;
using MrHomer.Networking;
using MrHomer.Security;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "Location Report by Label")]
    public class LocationReportLabelMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members

        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            CommunicationManager cms = CommunicationManager.getInstance();
            SecurityManager sm = SecurityManager.getInstance();
            StringData w = p.Body as StringData;
            string search = SearchResult.Sanitize(w.Data);
            Dictionary<String, LocationTask> dict = LocationTaskList.getInstance().GetTasks();
            if (dict.ContainsKey(search))
            {
                //Middle of search chain
                SendDataTask task = new SendDataTask();
                task.InitializeTask(Connection, new object[] { new Packet(p.Sender, p.Recipient, p.Subject, p.Body), sm.GetKey(Connection, null), null });
                cms.AddTask(task);
            }

            SearchCache.getInstance().AddResult(w.Data, Connection, null); 

        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Chris Scalabrini"; }
        }

        public string Version
        {
            get { return "1.0"; }
        }

        public string Label
        {
            get { return "Sends back sensor data."; }
        }

        #endregion
    }
}
