using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Networking;
using DuffBeer.Sensors;
using MrHomer.Plugins;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "Real-Time Data Removal Request")]
    public class RealTimeReportingRemoveRequestMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members

        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            StringData sensor = p.Body as StringData;
            Dictionary<string, FilterInformation> filters = SensorManager.getInstance().GetFiltersOnSensor(sensor.ToString());

            if (filters.ContainsKey("Real-Time Data Filter"))
                SensorManager.getInstance().RemoveFilter(sensor.ToString(), "Real-Time Data Filter");
        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { throw new Exception("The method or operation is not implemented."); }
        }

        public string Version
        {
            get { throw new Exception("The method or operation is not implemented."); }
        }

        public string Label
        {
            get { throw new Exception("The method or operation is not implemented."); }
        }

        #endregion
    }
}
