using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Plugins;
using MrHomer.Networking;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "Real-Time Data")]
    public class RealTimeReportingResponseMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members

        //Delegate and event for notifying the GUI of received data
        public delegate void RealTimeDataReceivedNotification(string data);
        public static RealTimeDataReceivedNotification RealTimeDataArrivedNotification;

        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            StringData data = p.Body as StringData;

            if (RealTimeDataArrivedNotification != null)
                RealTimeDataArrivedNotification(data.ToString());
        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Nathan Roy"; }
        }

        public string Version
        {
            get { return "V 0.1"; }
        }

        public string Label
        {
            get { return "Handles the receiving of real-time data, should only be used on requesting application side"; }
        }

        #endregion
    }
}
