using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Messages;
using MrHomer.Plugins;
using MrHomer.Networking;
using DuffBeer.Communication;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "Requesting Registered Machine Count")]
    public class RegisteredSystemNumberRequestMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members

        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            string subject = "";
            foreach (MrHomerPluginAttribute n in PluginManager.getInstance().getAttributes(typeof(RegisteredSystemNumberResponseMessageHandler)))
            {
                if (n.Name == "Subject")
                    subject = n.Value;
            }

            Packet q = new Packet(Brewery.getInstance().UPRN, Connection, subject, new StringData(CommunicationManager.getInstance().LowerConnections.Count.ToString()));

            SendDataTask task = new SendDataTask();
            task.InitializeTask(Connection, new object[] { q, MrHomer.Security.SecurityManager.getInstance().GetKey(Connection, new object[] { }), new object[] { } });
            CommunicationManager.getInstance().AddTask(task);
        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Brian O'Keefe"; }
        }

        public string Version
        {
            get { return "1.0"; }
        }

        public string Label
        {
            get { return "Sends back the number of registered systems."; }
        }

        #endregion
    }
}
