using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Messages;
using MrHomer.Plugins;
using DuffBeer.Messages.ProgressTaskStructures;
using MrHomer.Networking;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "Registered Machine Data")]
    public class RegisteredSystemResponseMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members

        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            SubSystemTaskList lst = SubSystemTaskList.getInstance();

            if (lst.GetTasks().ContainsKey(Connection) && !lst.GetTasks()[Connection].Done)
            {
                lst.GetTasks()[Connection].UPRNs.Add((p.Body as StringData).ToString());
            }

            if (lst.GetTasks()[Connection].Done)
            {
                Brewery.getInstance().SetVariable(Connection + "_SystemList", lst.GetTasks()[Connection].UPRNs);
            }
        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Brian O'Keefe"; }
        }

        public string Version
        {
            get { return "1.0"; }
        }

        public string Label
        {
            get { return "Sends back the number of registered systems."; }
        }

        #endregion
    }
}
