using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Messages;
using MrHomer.Plugins;
using MrHomer.Networking;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "Sensor Data")]
    public class SensorDataResponseMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members

        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            StringListData data = p.Body as StringListData;
            // Name, Timestamp, Average, Min, Max, Total
            
            Dictionary<string, string> d = new Dictionary<string, string>();
            d.Add("UPRN", p.Sender);
            d.Add("Name", data[0]);
            d.Add("Timestamp", data[1]);
            d.Add("Reading", data[2]);
            //d.Add("Min", data[3]);
            //d.Add("Max", data[4]);
            //d.Add("Total", data[5]);
            Brewery.getInstance().SetVariable(Connection + "_" + data[0] + "_Data", d);
        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Chris Scalabrini (modified by Nathan Roy)"; }
        }

        public string Version
        {
            get { return "1.1"; }
        }

        public string Label
        {
            get { return "Sends back sensor data."; }
        }

        #endregion
    }
}
