using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Messages;
using DuffBeer.Communication;
using MrHomer.Plugins;
using MrHomer.Networking;
using MrHomer.Security;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "Requesting Sensor List Count")]
    public class SensorListNumberRequestMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members
        //  Packet
        // Sender       =   Nothing, number
        // Recipient    =   Nothing
        // BOdy         =   Nothing


        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            string subject = "";
            foreach (MrHomerPluginAttribute n in PluginManager.getInstance().getAttributes(typeof(SensorListNumberResponseMessageHandler)))
            {
                if (n.Name == "Subject")
                    subject = n.Value;
            }
            int l = DuffBeer.Sensors.SensorManager.getInstance().GetCreatedSensors().Count;
            Packet i = new Packet(Brewery.getInstance().UPRN, p.Sender, subject, new StringData(l.ToString()));
            SendDataTask task = new SendDataTask();
            task.InitializeTask(Connection, new object[] { i, SecurityManager.getInstance().GetKey(Connection, null), new object[] { } });
            CommunicationManager.getInstance().AddTask(task);
        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Chris Scalabrini"; }
        }

        public string Version
        {
            get { return "1.0"; }
        }

        public string Label
        {
            get { return "Sends back sensor data."; }
        }

        #endregion
    }
}
