using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Messages;
using DuffBeer.Communication;
using MrHomer.Plugins;
using MrHomer.Networking;
using MrHomer.Security;
using DuffBeer.Messages.ProgressTaskStructures;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "Sensor List Count")]
    public class SensorListNumberResponseMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members

        //  Packet
        // Sender       =   number, Nothing
        // Recipient    =   Nothing
        // BOdy         =   Nothing
        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            StringData d = p.Body as StringData;
            int omg = int.Parse(d.Data);
            
            Dictionary<string, SensorTask> lol = SensorTaskList.getInstance().GetTasks();
            if (!lol.ContainsKey(Connection))
            {
                lol.Add(Connection, new SensorTask(omg));
                Reply(Connection, omg, lol);
            }
            else if (lol[Connection].Done)
            {
                lol[Connection] = new SensorTask(omg);
                Reply(Connection, omg, lol);
            }
        }

        private void Reply(string Connection, int omg, Dictionary<string, SensorTask> lst)
        {
            if (omg == 0)
            {
                Brewery.getInstance().SetVariable(Connection + "_SensorList", lst[Connection].Data);
                return;
            }

            string subject = "";
            foreach (MrHomerPluginAttribute n in PluginManager.getInstance().getAttributes(typeof(SensorListRequestMessageHandler)))
            {
                if (n.Name == "Subject")
                    subject = n.Value;
            }

            Packet l = new Packet(Brewery.getInstance().UPRN, Connection, subject, new StringData());
            SendDataTask task = new SendDataTask();
            task.InitializeTask(Connection, new object[] { l, SecurityManager.getInstance().GetKey(Connection, null), new object[] { } });
            CommunicationManager.getInstance().AddTask(task);
        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Chris Scalabrini"; }
        }

        public string Version
        {
            get { return "1.0"; }
        }

        public string Label
        {
            get { return "Sends back sensor data."; }
        }

        #endregion
    }
}
