using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Messages;
using MrHomer.Plugins;
using DuffBeer.Communication;
using MrHomer.Networking;
using DuffBeer.Sensors;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "Requesting Sensor List")]
    public class SensorListRequestMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members

        //Delegate and event for notifying the console that a sensor data request occured
        public delegate void SensorListRequestNotification(string from);
        public static SensorListRequestNotification RequestNotification;

        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            string subject = "";
            foreach (MrHomerPluginAttribute n in PluginManager.getInstance().getAttributes(typeof(SensorListResponseMessageHandler)))
            {
                if (n.Name == "Subject")
                    subject = n.Value;
            }

            //Added by nroy to notify the console of the request
            if (RequestNotification != null)
                RequestNotification("Computer at: " + Connection + " requested the sensor list.");

            // Time for WIN!!!
            foreach (string c in SensorManager.getInstance().GetCreatedSensors())
            {
                Packet baseP = new Packet(Brewery.getInstance().UPRN, Connection, subject, new StringData(c));
                SendDataTask task = new SendDataTask();
                task.InitializeTask(Connection, new object[] { baseP, MrHomer.Security.SecurityManager.getInstance().GetKey(Connection, new object[] { }), new object[] { } });
                CommunicationManager.getInstance().AddTask(task);
            }
        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Brian O'Keefe"; }
        }

        public string Version
        {
            get { return "1.0"; }
        }

        public string Label
        {
            get { return "Sends back the number of registered systems."; }
        }

        #endregion
    }
}
