using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Messages;
using MrHomer.Plugins;
using DuffBeer.Messages.ProgressTaskStructures;
using DuffBeer.Sensors;
using MrHomer.Networking;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "Sensor List Data")]
    public class SensorListResponseMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members

        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            // Expecting a magic list:
            // [Name], [Make], [Model], [Description], [SW Type]
            SensorTaskList lst = SensorTaskList.getInstance();

            if (lst.GetTasks().ContainsKey(Connection) && !lst.GetTasks()[Connection].Done)
            {
                // This is awful, but an exception here indicates shennanigans.
                StringData d = p.Body as StringData;
                lst.GetTasks()[Connection].Data.Add(d.Data);
            }
            
            if (lst.GetTasks().ContainsKey(Connection) && lst.GetTasks()[Connection].Done)
            {
                Brewery.getInstance().SetVariable(Connection + "_SensorList", lst.GetTasks()[Connection].Data);
            }
        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Chris Scalabrini"; }
        }

        public string Version
        {
            get { return "1.0"; }
        }

        public string Label
        {
            get { return "Sends back sensor data."; }
        }

        #endregion
    }
}
