using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Messages;
using DuffBeer.Messages.ProgressTaskStructures;
using DuffBeer.Communication;
using DuffBeer.Main;
using MrHomer.Plugins;
using MrHomer.Networking;
using MrHomer.Security;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "Requesting Deregistration")]
    public class SystemDeregistrationRequestMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members

        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            CommunicationManager cms = CommunicationManager.getInstance();
            DisconnectionTask task = new DisconnectionTask();
            task.InitializeTask(Connection,null);
            cms.AddTask(task);
        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Chris Scalabrini"; }
        }

        public string Version
        {
            get { return "1.0"; }
        }

        public string Label
        {
            get { return "Sends back sensor data."; }
        }

        #endregion
    }
}
