using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Messages;
using DuffBeer.Messages.ProgressTaskStructures;
using DuffBeer.Communication;
using DuffBeer.Main;
using MrHomer.Plugins;
using MrHomer.Networking;
using MrHomer.Security;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "Requesting Registration")]
    public class SystemRegistrationRequestMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members

        //   Packet 
        // Sender:      Name
        // Recipient:   HostName
        // Body:        StringData to int parse

        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            int port = int.Parse((p.Body as StringData).Data);
            ConnectionTask task = new ConnectionTask();
            task.InitializeTask(p.Sender, new object[] { p.Recipient, port, false });
            CommunicationManager.getInstance().AddTask(task);
        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Chris Scalabrini"; }
        }

        public string Version
        {
            get { return "1.0"; }
        }

        public string Label
        {
            get { return "Sends back sensor data."; }
        }

        #endregion
    }
}
