using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Messages;
using MrHomer.Plugins;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "Requesting User Deregistration")]
    public class UserDeregistrationMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members

        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            Serialization.UserInformation l = p.Body as Serialization.UserInformation;

            Database.StructureTypes.RegisteredUsersTableEntry table = Database.StructureTypes.RegisteredUsersTableEntry.Find(Database.StructureTypes.RegisteredUsersTableEntry.UsernameColumn, l.username);
            if (table != null)
            {
                if (table.Password.Equals(l.password))
                {
                    table.Delete();
                }
            }
        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Chris Scalabrini"; }
        }

        public string Version
        {
            get { return "1.0"; }
        }

        public string Label
        {
            get { return "Sends back sensor data."; }
        }

        #endregion
    }
}
