using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Messages;
using MrHomer.Plugins;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "Requesting User Recognition")]
    public class UserRecognitionRequestMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members

        //  Packet
        // Sender       =   Ignored, put in True/False
        // Recipient    =   Put Back In
        // Body         =   Put back in.

        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            Serialization.UserInformation l = p.Body as Serialization.UserInformation;


            bool pwn = false;
            Database.StructureTypes.RegisteredUsersTableEntry lol = Database.StructureTypes.RegisteredUsersTableEntry.Find(Database.StructureTypes.RegisteredUsersTableEntry.UsernameColumn, l.username);
            if (lol != null)
            {
                if (lol.Flags != 0)
                    pwn = true;
            }

            string subject = "";
            foreach (MrHomerPluginAttribute n in PluginManager.getInstance().getAttributes(typeof(UserRecognitionResponseMessageHandler)))
            {
                if (n.Name == "Subject")
                    subject = n.Value;
            }

            MrHomer.Networking.Packet r = new MrHomer.Networking.Packet(pwn.ToString(), p.Recipient, subject, l);
            Communication.SendDataTask task = new DuffBeer.Communication.SendDataTask();
            task.InitializeTask(Connection, new object[] { r, MrHomer.Security.SecurityManager.getInstance().GetKey(Connection, new object[] { }), new object[] { } });
            Communication.CommunicationManager.getInstance().AddTask(task);
        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Chris Scalabrini"; }
        }

        public string Version
        {
            get { return "1.0"; }
        }

        public string Label
        {
            get { return "Checks to see if a user is registered."; }
        }

        #endregion
    }
}
