using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Messages;
using MrHomer.Plugins;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "User Recognition Data")]
    public class UserRecognitionResponseMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members
        //  Packet
        // Sender       =   True if recognized, false otherwise
        // Recipient    =   Brewery Variable
        // Body         =   UserInformation on get

        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            Serialization.UserInformation l = p.Body as Serialization.UserInformation;
            if(p.Sender.Equals((true).ToString()))
            {
                Brewery.getInstance().SetVariable(p.Recipient, true);
                new Database.StructureTypes.RegisteredUsersTableEntry(l.username, l.password, 1);
            }
            else
                Brewery.getInstance().SetVariable(p.Recipient, false);
        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Chris Scalabrini"; }
        }

        public string Version
        {
            get { return "1.0"; }
        }

        public string Label
        {
            get { return "Processes the user recognition reception packet."; }
        }

        #endregion
    }
}
