using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Messages;
using MrHomer.Plugins;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "Requesting User Registration")]
    public class UserRegistrationRequestMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members
        //  Packet
        // Sender       =   Irrelevent, put in success (true/false)
        // Recipient    =   Put Back In
        // Body         =   UserInformation on get, put in error message on send.

        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            Serialization.UserInformation l = p.Body as Serialization.UserInformation ;

            Database.StructureTypes.RegisteredUsersTableEntry entry = Database.StructureTypes.RegisteredUsersTableEntry.Find(Database.StructureTypes.RegisteredUsersTableEntry.UsernameColumn, l.username);
            string subject = "";
            foreach (MrHomerPluginAttribute n in PluginManager.getInstance().getAttributes(typeof(UserRegistrationResponseMessageHandler)))
            {
                if (n.Name == "Subject")
                    subject = n.Value;
            }
            if (entry == null)
            {
                entry = new DuffBeer.Database.StructureTypes.RegisteredUsersTableEntry(l.username, l.password, l.cascade ? 1 : 0);
                entry.Save();
                MrHomer.Networking.Packet r = new MrHomer.Networking.Packet(true.ToString(), p.Recipient, subject, new MrHomer.Networking.StringData("User already exists."));
                Communication.SendDataTask task = new DuffBeer.Communication.SendDataTask();
                task.InitializeTask(Connection, new object[] { r, MrHomer.Security.SecurityManager.getInstance().GetKey(Connection, new object[] { }), new object[] { } });
                Communication.CommunicationManager.getInstance().AddTask(task);
            }
            else
            {
                MrHomer.Networking.Packet r = new MrHomer.Networking.Packet(false.ToString(), p.Recipient, subject, new MrHomer.Networking.StringData("User already exists."));
                Communication.SendDataTask task = new DuffBeer.Communication.SendDataTask();
                task.InitializeTask(Connection, new object[] { r, MrHomer.Security.SecurityManager.getInstance().GetKey(Connection, new object[] { }), new object[] { } });
                Communication.CommunicationManager.getInstance().AddTask(task);

            }

        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Chris Scalabrini"; }
        }

        public string Version
        {
            get { return "1.0"; }
        }

        public string Label
        {
            get { return "Sends back sensor data."; }
        }

        #endregion
    }
}
