using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Messages;
using MrHomer.Plugins;
using MrHomer;

namespace DuffBeer.Messages.MessageTypes
{
    [MrHomerPlugin("Subject", "User Registration Response")]
    public class UserRegistrationResponseMessageHandler : IMessageHandler
    {
        #region IMessageHandler Members
        //  Packet
        // Sender       =   True if successful, false otherwise
        // Recipient    =   Brewery Variable
        // Body         =   Error message, if any

        public void Invoke(MrHomer.Networking.Packet p, string Connection)
        {
            MrHomer.Networking.StringData l = p.Body as MrHomer.Networking.StringData;

            if (p.Sender.Equals(true.ToString()))
            {
                Brewery.getInstance().SetVariable(p.Recipient, true);
            }
            else
            {
                Brewery.getInstance().SetVariable(p.Recipient, false);
                ErrorManager.getInstance().Catch(new Exception(l.Data));
            }
        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Chris Scalabrini"; }
        }

        public string Version
        {
            get { return "1.0"; }
        }

        public string Label
        {
            get { return "Response to user registration."; }
        }

        #endregion
    }
}
