using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Networking;

namespace DuffBeer.Messages.Serialization
{
    public class UserInformation : IHSerializable
    {
        #region IHSerializable Members

        public string username;
        public string password;
        public bool cascade;

        public UserInformation()
            : this("", "", false)
        {
        }

        public UserInformation(string username, string pass, bool cascade)
        {
            this.username = username;
            this.password = pass;
            this.cascade = cascade;
        }

        public byte[] Serialize()
        {
            StringListData d = new StringListData();
            d.Add(username);
            d.Add(password);
            d.Add(cascade.ToString());
            return d.Serialize();
        }

        public void Deserialize(byte[] data)
        {
            StringListData d = new StringListData();
            d.Deserialize(data);
            username = d[0];
            password = d[1];
            if (d[2].Equals((true).ToString()))
                cascade = true;
            else
                cascade = false;
        }

        #endregion
    }
}
