using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Security;

namespace DuffBeer.Security.Cryptography
{
    public sealed class Multi_Cryptographer : List<ICryptographer>, ICryptographer
    {
        #region ICryptographer Members

        /// <summary>
        /// Encrypts the given data with all of the Cryptographers in the list
        /// </summary>
        /// <param name="data">The data to encrypt</param>
        /// <param name="Details">Any additional information for the Cryptographer</param>
        /// <returns>The encrypted data</returns>
        public byte[] Encrypt(byte[] data, byte[] Key, object[] Details)
        {
            byte[] working = (byte[])data.Clone();
            for (int i = 0; i < this.Count; i++)
                working = this[i].Encrypt(working, Key, Details);
            return working;
        }

        /// <summary>
        /// Decrypts the given data with all of the Cryptographers in the list
        /// </summary>
        /// <param name="data">The data to decrypt</param>
        /// <param name="Details">Any additional information for the Cryptographer</param>
        /// <returns>The decrypted data</returns>
        public byte[] Decrypt(byte[] data, byte[] Key, object[] Details)
        {
            byte[] working = (byte[])data.Clone();
            for (int i = this.Count - 1; i >= 0; i--)
                working = this[i].Decrypt(working, Key, Details);
            return working;
        }

        #endregion
    }
}
