using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Security;

namespace DuffBeer.Security.Cryptography
{
    public class NRotN_Crypto : ICryptographer
    {
        #region ICryptographer Members

        public byte[] Encrypt(byte[] data, byte[] Key, object[] Details)
        {
            byte[] cyphertext = new byte[data.Length];
            byte rotation = 0;
            
            for (int x = 0; x < data.Length; x++)
            {
                rotation = (byte)((rotation + Key[x % Key.Length]) % (byte.MaxValue + 1));
                cyphertext[x] = (byte)((data[x] + rotation) % (byte.MaxValue + 1));
            }

            return cyphertext;
        }

        public byte[] Decrypt(byte[] data, byte[] Key, object[] Details)
        {
            byte[] plaintext = new byte[data.Length];
            byte rotation = 0;

            for (int x = 0; x < data.Length; x++)
            {
                rotation = (byte)((rotation + Key[x % Key.Length]) % (byte.MaxValue + 1));
                plaintext[x] = (byte)((data[x] - rotation) % (byte.MaxValue + 1));
            }

            return plaintext;
        }

        #endregion
    }
}
