using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Security;
using MrHomer.Database;
using MrHomer.Database.Query;
using DuffBeer;
using DuffBeer.Database.StructureTypes;

namespace DuffBeer.Security.Key_Stores
{
    public class DBKeyStore : IKeyManager
    {
        #region IKeyManager Members
        
        public byte[] GetKey(string Name, object[] Details)
        {
            KeyStoreTableEntry r = KeyStoreTableEntry.Find("Name", Name);

            if (r == null)
                return null;
            else
                return Encoding.UTF8.GetBytes(r.AuthKey);
        }

        public void SetKey(string Name, byte[] Key, object[] Details)
        {
            KeyStoreTableEntry r = KeyStoreTableEntry.Find("Name", Name);

            if (r == null)
            {
                r = new KeyStoreTableEntry(Name, Encoding.UTF8.GetString(Key));
                r.Save();
            }
            else
            {
                r.AuthKey = Encoding.UTF8.GetString(Key);
                r.Save();
            }
        }

        public bool ContainsKey(string Name, object[] Details)
        {
            return KeyStoreTableEntry.Find("Name", Name) != null;
        }

        /// <summary>
        /// Removes the key for an object
        /// </summary>
        /// <param name="Name">The key name</param>
        /// <param name="Details">Additional information about the object</param>
        public void RemoveKey(string Name, object[] Details)
        {
            KeyStoreTableEntry r = KeyStoreTableEntry.Find("Name", Name);

            if (r != null)
            {
                r.Delete();
            }
        }

        #endregion
    }
}
