using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Networking;
using MrHomer.Plugins;

namespace DuffBeer.Sensors.Utility
{
    /// <summary>
    /// A data reading used by the ISensor interface.
    /// </summary>
    [MrHomerPlugin("Name", "Database Sensor")]
    [MrHomerPlugin("Description", "Writes stuff to database.  Simple.")]
    public class DataReading : IHSerializable
    {
        #region Private Fields
        private string sensor;
        private double sValue;
        private string time;
        #endregion

        #region Properties
        public string SensorID
        {
            get
            {
                return sensor;
            }
        }

        public double Value
        {
            get
            {
                return sValue;
            }
        }

        public string Time
        {
            get
            {
                return time;
            }
        }
        #endregion

        #region Constructor
        public DataReading(string sensorID, double sensorValue, string time)
        {
            sensor = sensorID;
            sValue = sensorValue;
            this.time = time;
        }
        #endregion

        #region IHSerializable
        public byte[] Serialize()
        {
            StringData s = new StringData(sensor);
            byte[] sb = s.Serialize();
            byte[] sl = BitConverter.GetBytes(sb.Length);
            byte[] rb = BitConverter.GetBytes(sValue);
            List<byte> list = new List<byte>();
            list.AddRange(sl);
            list.AddRange(sb);
            list.AddRange(rb);
            return list.ToArray();
        }

        public void Deserialize(byte[] data)
        {
            int length = 0;
            int offset = 0;

            length = BitConverter.ToInt32(data, offset);
            offset += 4;
            sensor = (new UTF8Encoding()).GetString(data, offset, length);
            offset += length;
            sValue = BitConverter.ToDouble(data, offset);
        }


        #endregion


    }
}
