using System;
using System.Collections.Generic;
using MrHomer.Plugins;
using System.Text;

namespace DuffBeer.Sensors
{
    /// <summary>
    /// A class that holds data about filters.
    /// </summary>
    public class FilterInformation
    {
        private string name;
        private string description; 

        /// <summary>
        /// The name of the filter.
        /// </summary>
        public string Name
        { get { return name; } }

        /// <summary>
        /// The description of the filter.
        /// </summary>
        public string Description
        { get { return description; } }

        /// <summary>
        /// Main constructor.
        /// </summary>
        /// <param name="myName">The name.</param>
        /// <param name="myDescription">The description.</param>
        public FilterInformation(string myName, string myDescription)
        {
            name = myName;
            description = myDescription;
        }

        /// <summary>
        /// The cooler constructor.  Autopopulates based on a Type.
        /// </summary>
        /// <param name="t">The type.</param>
        public FilterInformation(Type t)
        {
            PluginManager pm = PluginManager.getInstance();
            if (!pm.EnforceAttributes("Required", t))
            {
                throw new SensorException(t.Name + "Did not include all attributes.");
            }
            List<MrHomerPluginAttribute> list = pm.getAttributes(t);
            foreach (MrHomerPluginAttribute att in list)
            {
                if (att.Name.ToLower() == "name")
                    name = att.Value;
                if (att.Name.ToLower() == "description")
                    description = att.Value;
            }
        }
    }
}
