using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Plugins;
using DuffBeer.Sensors.Interfaces;
using DuffBeer.Sensors.Utility;

namespace DuffBeerPluginLibrary.Plugins
{
    [MrHomerPlugin("Name", "Software Sensor: Random")]
    [MrHomerPlugin("Make", "Fake Sensor")]
    [MrHomerPlugin("Model", "Wun-2-fif-T")]
    [MrHomerPlugin("Description", "Not to be used in any real examples.  Only a test.")]
    public class RandomSensor : ISensor
    {
        private static int number;
        private string name;
        public RandomSensor()
        {
            name = "Random" + (RandomSensor.number++);
        }

        public string GetUnits()
        {
            return "Marklar";
        }

        public void SetName(string s)
        {
            name = s;
        }

        public byte[] SerializeConfiguration()
        {
            return (new UTF8Encoding()).GetBytes(name);
        }

        public void DeserializeConfiguration(byte[] data)
        {
            name = (new UTF8Encoding()).GetString(data);
        }

        public string Author { get { return "Chris Scalabrini"; } }
        public string Version { get { return "1.2"; } }
        public string Label { get { return "Random"; } }


        #region ISensor Members

        object ISensor.RequestData()
        
        {
             return new DataReading(name, (new Random()).NextDouble() * 50, DateTime.Now.ToString());    
        }

        public Type ReturnType
        {
            get { return typeof(DataReading); }
        }

        #endregion
    }
}
