using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Plugins;
using DuffBeer.Sensors.Interfaces;
using DuffBeer.Sensors.Utility;

namespace DuffBeerPluginLibrary.Plugins
{
    [MrHomerPlugin("Name", "Software Sensor: SMRT")]
    [MrHomerPlugin("Make", "Fake Sensor")]
    [MrHomerPlugin("Model", "hoo-nose")]
    [MrHomerPlugin("Description", "Not to be used in any real examples.  Only a test.")]
    public class SMRTSensor : ISensor
    {
        static private int number;
        private double previous;
        private string name;
        private Random r;
        private int behavior;
        private int type;
        public SMRTSensor()
        {
            name = "SMRT" + (SMRTSensor.number++);
            r = new Random(DateTime.Now.Millisecond);
            previous = r.NextDouble() * 50.0;
        }

        public string GetUnits()
        {
            return "Marklar";
        }

        public void SetName(string s)
        {
            name = s;
        }

        public byte[] SerializeConfiguration()
        {
            return (new UTF8Encoding()).GetBytes(name);
        }

        public void DeserializeConfiguration(byte[] data)
        {
            name = (new UTF8Encoding()).GetString(data);
        }

        public string Author { get { return "Chris Scalabrini"; } }
        public string Version { get { return "1.0"; } }
        public string Label { get { return "SMRT"; } }


        #region ISensor Members

        public object RequestData()
        {
            double value = 0.0;
            if (behavior == 0)
            {
                value = previous;
                value += r.NextDouble()*8 - 4.0;
                value = Math.Max(value, 0);
                previous = value;
                if (r.Next(256) < 5)
                {
                    type = (int)(r.NextDouble() * 2);
                    behavior = r.Next(10);
                }
            }
            else
            {
                if (type == 0)
                {
                    value = 0.0;
                }
                else
                {
                    value = previous;
                    value *= 2 + r.NextDouble();
                }
                behavior--;
            }
            return new DataReading(name, value, DateTime.Now.ToString());    
        }

        public Type ReturnType
        {
            get { return typeof(DataReading); }
        }

        #endregion
    }
}
