using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Plugins;

namespace MrHomer.Database
{
    /// <summary>
    /// If you'd like to include your own types in the Database Manager,
    /// extend this type, then pass it to the DatabaseManager.
    /// </summary>
    [MrHomerPlugin("Required", "Type")]
    public interface IDatabaseFactory : IPlugin
    {
        /// <summary>
        /// The custom type of IDatabase you are producing is created here.
        /// </summary>
        /// <param name="Arguments">Any arguments it might need.</param>
        /// <returns>The IDatabase.</returns>
        IDatabase GetDatabase(object[] Arguments);
    }
}
