using System;
using System.Collections.Generic;
using System.Text;
using MrHomer.Plugins;

namespace MrHomer.Database.Query
{
    [MrHomerPlugin("Required", "Type")]
    public interface IQueryBuilder : IPlugin
    {
        string Alias(string Query, string Alias);
        string And(string Condition1, params string[] Conditions);
        string Avg(string Column);
        string Between(string Column, string LBound, params string[] UBound);
        string Concat(string Field1, params string[] Fields);
        string Count(string Column);
        string CountDistinct(string Column);
        string Delete(string Table, string Condition);
        string GroupBy(string Query, string Column1, params string[] Columns);
        string In(string Column, string Option1, params string[] Options);
        string Insert(string Table, params System.Collections.Generic.KeyValuePair<string, string>[] values);
        string Join(string Query1, string Query2, string Condition, string JoinType);
        string Like(string Column, string Condition);
        string Max(string Column);
        string Min(string Column);
        string Not(string Condition);
        string Or(string Condition1, params string[] Conditions);
        string OrderBy(string Query, System.Collections.Generic.KeyValuePair<string, bool> Column1, params System.Collections.Generic.KeyValuePair<string, bool>[] Columns);
        string Select(string Table, params string[] Columns);
        string SelectDistinct(string Table, params string[] Columns);
        string SelectDistinctWhere(string Table, string Condition, params string[] Columns);
        string SelectWhere(string Table, string Condition, params string[] Columns);
        string Sum(string Column);
        string Update(string Table, string Condition, params System.Collections.Generic.KeyValuePair<string, string>[] values);
    }
}
