using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.Net.Sockets;

namespace AsyncSockets
{
    public class SocketEventArgs : EventArgs
    {
        public EndPoint LocalAddress, RemoteAddress;
        
        public SocketEventArgs(EndPoint local, EndPoint remote)
        {
            LocalAddress = local;
            RemoteAddress = remote;
        }
    }

    public class SocketConnectEventArgs : EventArgs
    {
        public AsyncSocket ConnectedClient;

        public SocketConnectEventArgs(AsyncSocket newSocket)
        {
            ConnectedClient = newSocket;
        }
    }

    public class SocketDataEventArgs : SocketEventArgs
    {
        public int Bytes;
        public byte[] Data;
        public AsyncSocket.State State;

        public SocketDataEventArgs(EndPoint local, EndPoint remote, int bytes, byte[] socketData, AsyncSocket.State state)
            : base(local, remote)
        {
            Bytes = bytes;
            Data = socketData;
            State = state;
        }
    }
}
