using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;
using MrHomer;

namespace AsyncSockets
{
    public class AsyncSocketException : Exception
    {
        /// <summary>
        /// Creates a new instance of the exception
        /// </summary>
        public AsyncSocketException()
        {
        }

        /// <summary>
        /// Creates a new instance of the exception
        /// </summary>
        /// <param name="message">A message describing the error</param>
        public AsyncSocketException(string message) : base(message)
        {
        }

        /// <summary>
        /// Creates a new instance of the exception
        /// </summary>
        /// <param name="message">A message describing the error</param>
        /// <param name="innerException">The exception that originally caused this exception</param>
        public AsyncSocketException(string message, Exception innerException) : base(message, innerException) 
        {
        }

        /// <summary>
        /// Creates a new instance of the exception with serialized data
        /// </summary>
        /// <param name="info">Holds the serialized object data about the exception being thrown</param>
        /// <param name="context">Contains contextual information about the source or destination</param>
        public AsyncSocketException(SerializationInfo info, StreamingContext context) : base(info, context) 
        {
        }

    }
}
