using System;
using System.Collections.Generic;
using System.Text;

namespace MrHomer.Networking
{
    /// <summary>
    /// Objects inheriting from this class can be serialized or deserialize from a byte stream.
    /// </summary>
    public interface IHSerializable
    {
        /// <summary>
        /// All data in the object needed to restore state is converted to a byte stream.
        /// </summary>
        /// <returns>The bytes representing the object.</returns>
        byte[] Serialize();

        /// <summary>
        /// Given a byte stream, the object must be able to be restored.
        /// </summary>
        /// <param name="data">The byte stream.</param>
        void Deserialize(byte[] data);
    }
}
