using System;
using System.Collections.Generic;
using System.Text;

namespace MrHomer.Networking
{
    /// <summary>
    /// An IHSerializable version of a string.
    /// </summary>
    public class StringData : IHSerializable
    {
        private string data;
        /// <summary>
        /// The actual string.
        /// </summary>
        public string Data
        {
            get
            {
                return data;
            }
            set
            {
                data = value;
            }
        }

        /// <summary>
        /// An empty constructor.
        /// </summary>
        public StringData()
        {
            data = "";
        }

        /// <summary>
        /// The main constructor.
        /// </summary>
        /// <param name="s">The string it's to contain.</param>
        public StringData(string s)
        {
            data = s;
        }

        /// <summary>
        /// Serializes the StringData as a byte stream.
        /// </summary>
        /// <returns>The byte stream.</returns>
        public byte[] Serialize()
        {
            System.Text.UTF8Encoding encoder = new UTF8Encoding();
            return encoder.GetBytes(data);
        }

        /// <summary>
        /// Deserializes the byte stream.
        /// </summary>
        /// <param name="myData">The byte stream.</param>
        public void Deserialize(byte[] myData)
        {
            System.Text.UTF8Encoding encoder = new UTF8Encoding();
            data = encoder.GetString(myData);
        }

        /// <summary>
        /// Converts the StringData to a String
        /// </summary>
        /// <returns>A String</returns>
        public override string ToString()
        {
            return data;
        }
    }
}
