using System;
using System.Collections.Generic;
using System.Text;

namespace MrHomer.Plugins
{
    /// <summary>
    /// All plugin interfaces (and only plugin interaces) MUST inherit from this interface.
    /// It's the only way the plugin manager will accept it as a plugin prototype.
    /// </summary>
    public interface IPlugin
    {
        /// <summary>
        /// The plugin's author.  Get only.
        /// </summary>
        string Author{ get;}
        /// <summary>
        /// The plugin's version.  Get only.
        /// </summary>
        string Version{ get;}
        /// <summary>
        /// The plugin's name.  Get only.
        /// </summary>
        string Label{ get;}
    }
}
