using System;
using System.Collections.Generic;
using System.Text;

namespace MrHomer.Plugins
{
    /// <summary>
    /// This class represents the MrHomerPluginAttribute.  It's a generic two-string attribute.  This can be used
    /// to enforce certain data to be specified by plugins (for example, sensor make and model).  It can also be
    /// used on plugin interfaces.
    /// </summary>
    [AttributeUsage(AttributeTargets.Class | AttributeTargets.Interface, AllowMultiple=true)]
    public sealed class MrHomerPluginAttribute : Attribute
    {
        #region Private Fields
        private string name;
        private string value;
        #endregion

        #region Constructor
        public MrHomerPluginAttribute(string myName, string myValue)
        {
            name = myName;
            value = myValue;
        }
        #endregion

        #region Properties
        public string Name { get { return name; } }
        public string Value { get { return value; } }
        #endregion
    }
}
