using System;
using System.Collections.Generic;
using System.Text;
using AsyncSockets;

namespace MrHomer.Security
{
    public interface IAuthenticator
    {
        /// <summary>
        /// Attempts to determine if the specified object is registered
        /// </summary>
        /// <param name="Name">The object to check</param>
        /// <param name="Type">The type of object</param>
        /// <param name="Details">Additional information about the object</param>
        /// <returns>The object's registration status</returns>
        bool IsRegistered(string Name, string Type, object[] Details);

        /// <summary>
        /// Authenticates an object
        /// </summary>
        /// <param name="Name">The object to authenticate</param>
        /// <param name="Type">The type of object</param>
        /// <param name="Details">Additional information about the object</param>
        /// <returns>The object's authentication status</returns>
        bool Authenticate(string Name, string Type, object[] Details);
    }
}
