using System;
using System.Collections.Generic;
using System.Text;

namespace MrHomer.Security
{
    public interface ICryptographer
    {
        /// <summary>
        /// Encrypts a byte stream
        /// </summary>
        /// <param name="data">The plain text</param>
        /// <param name="Key">The encryption key</param>
        /// <param name="Details">Additional information for the encryption</param>
        /// <returns>The cypher text</returns>
        byte[] Encrypt(byte[] data, byte[] Key, object[] Details);

        /// <summary>
        /// Decrypts a byte stream
        /// </summary>
        /// <param name="data">The cypher text</param>
        /// <param name="Key">The encryption key</param>
        /// <param name="Details">Additional information about the object</param>
        /// <returns>The plain text</returns>
        byte[] Decrypt(byte[] data, byte[] Key, object[] Details);
    }
}
