using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MrHomerDriver
{
    public partial class ConnectionManagerTestPanel : Form
    {
        ConnectionManagerTestBackend lol;
        public ConnectionManagerTestPanel()
        {
            InitializeComponent();
            lol = ConnectionManagerTestBackend.getInstance();
        }

        private void btnSetCred_Click(object sender, EventArgs e)
        {
            lol.SetCredentials(txtCred.Text);
        }

        private void btnReqPack_Click(object sender, EventArgs e)
        {
            lol.SetRequestPacket(txtReqPacket.Text);
        }

        private void btnTimeout_Click(object sender, EventArgs e)
        {
            lol.SetTimeout(int.Parse(txtTimeout.Text), chkTimeout.Checked);

        }

        private void btnConnect_Click(object sender, EventArgs e)
        {
            lol.MakeConnection(txtMakeConnLabel.Text, txtMakeConnHost.Text, int.Parse(txtMakeConnPort.Text));

        }

        private void btnStartListen_Click(object sender, EventArgs e)
        {
            lol.ListenOnPort(int.Parse(txtListenPort.Text));

        }

        private void btnEndListen_Click(object sender, EventArgs e)
        {
            lol.StopListening(int.Parse(txtListenPort.Text));

        }

        private void btnKillConn_Click(object sender, EventArgs e)
        {
            lol.KillConnection(txtKillLabel.Text);

        }

        private void btnSend_Click(object sender, EventArgs e)
        {
            lol.SendData(txtDataLabel.Text, txtDataData.Text);

        }

        private void btnReceive_Click(object sender, EventArgs e)
        {
            lol.GetData(txtDataLabel.Text);

        }

        private void btnLisPorts_Click(object sender, EventArgs e)
        {
            lol.ListeningPorts();
        }

        private void btnGetInactive_Click(object sender, EventArgs e)
        {
            lol.ListInactive();
        }

        private void btnGetActive_Click(object sender, EventArgs e)
        {
            lol.ListActive();
        }

        private void btnGetDropped_Click(object sender, EventArgs e)
        {
            lol.GetDropped();
        }

        private void btnClear_Click(object sender, EventArgs e)
        {
            lol.Clear();
        }

        private void btnActivate_Click(object sender, EventArgs e)
        {
            lol.ActivateConnection(txtActInact.Text, txtActNewname.Text);
        }

        private void btnFail_Click(object sender, EventArgs e)
        {
            lol.GetFailed();
        }
    }
}