using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MrHomer.Plugins;

namespace MrHomerDriver
{
    public partial class PluginTestForm : Form
    {

        List<string> lines;
        public PluginTestForm()
        {
            InitializeComponent();
            lines = new List<string>();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            open.ShowDialog();
        }

        private void open_FileOk(object sender, CancelEventArgs e)
        {
            string filename = open.FileName;
            lines.Add("Attempting: " + filename);
            PluginManager pm = PluginManager.getInstance();
            try
            {
                pm.LoadInterfaceTypes(filename);
                pm.LoadPluginTypes(filename);
                foreach (Type t in pm.getInterfaces())
                {
                    lines.Add("Loaded Interface: " + t.Name);
                    foreach (Type l in pm.getPlugins(t))
                    {
                        lines.Add("--Loaded Plugin: " + l.Name);
                    }
                }
                lines.Add("Process Complete.");
            }
            catch (Exception E)
            {
                lines.Add("Exception: " + E.Message);
                lines.Add("Process Aborted.");
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            textBox1.Lines = lines.ToArray();
        }
    }
}