using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using AsyncSockets;
using System.Net;
using System.Net.Sockets;
using MrHomer.Security;
using MrHomerDriver.TestClasses;

namespace MrHomerDriver
{
    public partial class frmAuthenticationAcceptor : Form
    {
        private AsyncSocket listener;
        private ICryptographer crypt;
        private IAuthenticator auth;
        private IKeyManager keys;
        private DemoAuthSystem syst;

        public frmAuthenticationAcceptor()
        {
            InitializeComponent();

            crypt = new CryptoDemo();
            auth = new AuthDemo();
            keys = new KeyDemo();

            syst = new DemoAuthSystem(SecurityManager.getInstance(auth, crypt, keys));

            listener = new AsyncSocket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            syst.AuthenticationCompleted += new DemoAuthSystem.AuthenticationEvent(SecurityManager_AuthenticationCompleted);
        }

        private void frmAuthenticationAcceptor_Load(object sender, EventArgs e)
        {
            listener.AcceptedConnection += new AsyncSocket.AsyncSocketConnectEvent(syst.AuthenticateServer);
            listener.SocketError += new AsyncSocket.AsyncSocketErrorEvent(test_SocketError);
            listener.Bind(new IPEndPoint(0, 9999));
            listener.Listen(5);
            listener.Accept();
        }

        void SecurityManager_AuthenticationCompleted(object sender, SocketConnectEventArgs e)
        {
            MessageBox.Show("Authenticated!");
        }

        void test_SocketError(object sender, AsyncSocketException e)
        {
            MessageBox.Show("Socket Error: " + e.Message);
        }
    }
}