using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MrHomer.Security;
using AsyncSockets;
using System.Net.Sockets;
using System.Net;
using MrHomerDriver.TestClasses;

namespace MrHomerDriver
{
    public partial class frmAuthenticationTester : Form
    {
        private ICryptographer crypt;
        private IAuthenticator auth;
        private IKeyManager keys;
        private DemoAuthSystem syst;

        public frmAuthenticationTester()
        {
            crypt = new CryptoDemo();
            auth = new AuthDemo();
            keys = new KeyDemo();

            syst = new DemoAuthSystem(SecurityManager.getInstance(auth, crypt, keys));

            InitializeComponent();
        }

        private void cmdStart_Click(object sender, EventArgs e)
        {
            AsyncSocket test = new AsyncSocket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            test.Connected += new AsyncSocket.AsyncSocketEvent(test_Connected);
            test.SocketError += new AsyncSocket.AsyncSocketErrorEvent(test_SocketError);
            test.Connect("localhost", 9999);
        }

        void test_SocketError(object sender, AsyncSocketException e)
        {
            MessageBox.Show("Socket Error: " + e.Message);
        }

        void test_Connected(object sender, SocketEventArgs e)
        {
            syst.Authenticate((AsyncSocket)sender, "SomeHost");
        }
    }
}