using System;
using System.Collections.Generic;
using System.Text;
using DuffBeer.Sensors.Interfaces;
using MrHomer.Plugins;

namespace On_Site_Server
{
    [MrHomerPlugin("Name", "Test Sensor")]
    [MrHomerPlugin("Make", "Test Company")]
    [MrHomerPlugin("Model", "Test 01")]
    [MrHomerPlugin("Description", "Test Sensor for Showing how to write plug-ins")]
    class TestSensor : ISensor
    {
        #region Variables

        private string name;

        #endregion

        #region ISensor Members

        public object RequestData()
        {
            return new Random().NextDouble() * 10;
        }

        public string GetUnits()
        {
            return "KwH";
        }

        public void SetName(string name)
        {
            this.name = name;
        }

        public byte[] SerializeConfiguration()
        {
            return (new UTF8Encoding()).GetBytes(name);
        }

        public void DeserializeConfiguration(byte[] data)
        {
            name = (new UTF8Encoding()).GetString(data);
        }

        public Type ReturnType
        {
            get { return typeof(Double); }
        }

        #endregion

        #region IPlugin Members

        public string Author
        {
            get { return "Nathan Roy"; }
        }

        public string Version
        {
            get { return "0.1"; }
        }

        public string Label
        {
            get { return name; }
        }

        #endregion
    }
}
